<?php

    use pachno\modules\livelink_github\Connector;

    /**
     * @var Connector $connector
     */

?>
<style>
    .address-container:before {
        background-image: url('<?= image_url('github_icon_large.png', false, 'livelink_github'); ?>');
    }
</style>
<div class="backdrop_box large" id="livelink_configure_import">
    <div class="backdrop_detail_header">
        <span><?= ($project->getId()) ? __('Link existing project') : __('Import project from GitHub'); ?></span>
        <a class="closer" href="javascript:void(0);"><?= fa_image_tag('times'); ?></a>
    </div>
    <div id="backdrop_detail_content" class="backdrop_detail_content">
        <div class="form-container">
            <?php if (!$connector->isConfigured()): ?>
                <div class="form">
                    <div class="form-row">
                        <div class="message-box type-info">
                            <?= fa_image_tag('info-circle', ['class' => 'icon']); ?>
                            <div class="message">
                                <?= __('Before you can import or link a project, you need to connect your GitHub profile in the "%external_accounts" section of your account settings', ['%external_accounts' => __('External accounts')]); ?>
                            </div>
                            <div class="actions">
                                <a href="<?= make_url('profile_account'); ?>" class="button secondary highlight"><?= __('Open settings'); ?></a>
                            </div>
                        </div>
                    </div>
                </div>
            <?php else: ?>
                <form class="step-form step-1" action="<?= make_url('livelink_github_configure_project_settings', ['project_id' => $project->getID()]); ?>" accept-charset="<?= \pachno\core\framework\Context::getI18n()->getCharset(); ?>" method="post" onsubmit="return false;" id="livelink_github_connector_form">
                    <div class="form-row">
                        <div class="address-settings">
                            <p><?= __('Enter the github repository name, github url or git clone url for the project you want to link or import.'); ?></p>
                            <input type="hidden" name="setup-step" value="1" id="livelink_github_setup_step">
                            <input type="hidden" name="connector" value="github">
                            <input type="hidden" name="project_id" value="<?= $project->getID(); ?>">
                            <div class="address-container" id="livelink_address_container">
                                <?= fa_image_tag('check', ['class' => 'verified-ok']); ?>
                                <input type="text" id="livelink_repository_url_input" name="repository_url" placeholder="<?= __('Enter a github url, project name or clone url here'); ?>">
                            </div>
                            <a href="#" id="livelink_change_button" class="button button-silver change-button"><?= __('Change'); ?></a>
                        </div>
                    </div>
                    <div class="livelink_integration_settings visible-step step-2">
                        <div class="form-row disabled">
                            <input type="radio" disabled value="full" class="fancy-checkbox" name="live_link" id="github_update_issues_checkbox"><label for="github_update_issues_checkbox"><?= fa_image_tag('check-square', ['class' => 'checked'], 'far') . fa_image_tag('square', ['class' => 'unchecked'], 'far'); ?><span><?= __('Import project and enable two-way linking'); ?></span><span class="count-badge"><?= __('Disabled in this release'); ?></span></label>
                            <span class="explanation disabled"><?= __('Imports the project and relevant information into Pachno and enables two-way linking.'); ?></span>
                        </div>
                        <div class="form-row disabled">
                            <input type="radio" disabled value="simple" class="fancy-checkbox" name="live_link" id="github_hook_issues_checkbox"><label for="github_hook_issues_checkbox"><?= fa_image_tag('check-square', ['class' => 'checked'], 'far') . fa_image_tag('square', ['class' => 'unchecked'], 'far'); ?><span><?= __("Create and link the project but don't import existing data"); ?></span><span class="count-badge"><?= __('Disabled in this release'); ?></span></label>
                            <span class="explanation disabled"><?= __("Creates the project and enables two-way linking, but does not import any project data (such as issues, etc) into Pachno."); ?></span>
                        </div>
                        <div class="form-row">
                            <input type="radio" value="import" checked class="fancy-checkbox" name="live_link" id="github_link_issues_checkbox"><label for="github_link_issues_checkbox"><?= fa_image_tag('check-square', ['class' => 'checked'], 'far') . fa_image_tag('square', ['class' => 'unchecked'], 'far'); ?><span><?= __("Import project from GitHub but don't enable linking"); ?></span></label>
                            <span class="explanation"><?= __("Only imports the project and relevant information into Pachno but does not enable two-way linking."); ?></span>
                        </div>
                    </div>
                    <div class="form-row submit-container visible-step step-1">
                        <button type="submit" class="button primary"><?= fa_image_tag('spinner', ['class' => 'indicator fa-spin']) . __('Next'); ?></button>
                    </div>
                    <div class="form-row submit-container visible-step step-2">
                        <button type="submit" class="button primary"><?= fa_image_tag('spinner', ['class' => 'indicator fa-spin']) . __('Finish'); ?></button>
                    </div>
                </form>
            <?php endif; ?>
        </div>
    </div>
<script>
    Pachno.on(Pachno.EVENTS.fetch.updated, () => {
        const form_id        = 'livelink_github_connector_form',
            $form          = $('#' + form_id),
            $step_input    = $('#livelink_github_setup_step'),
            $repo_input    = $('#livelink_repository_url_input'),
            $change_button = $('#livelink_change_button');

        const loadProjectInfo = function (e) {
            <?php if ($project->getID()): ?>
                const $submit_button = $('.' + form_id + '_button'),
                    url            = $form.attr("action");

                $submit_button.attr('disabled', true);
                $form.addClass('submitting');
                e.preventDefault();

                const submitProjectStep = function () {
                    return new Promise(function (resolve, reject) {
                        $.ajax({
                            type: 'POST',
                            data: $form.serialize(),
                            url: url,
                            success: resolve,
                            error: function (details) {
                                $form.removeClass('submitting');
                                $submit_button.attr('disabled', false);
                                reject(details);
                            }
                        });
                    });
                };

                const loadLivelinkPartial = function () {
                    return new Promise(function (resolve, reject) {
                        $.ajax({
                            type: 'GET',
                            url: '<?= make_url('get_project_connector_template', ['project_id' => $project->getID()]); ?>',
                            success: resolve,
                            error: function (details) {
                                $form.removeClass('submitting');
                                $submit_button.attr('disabled', false);
                                reject(details);
                            }
                        });
                    });
                };

                submitProjectStep()
                    .then(loadLivelinkPartial)
                    .then(function (content) {
                        $('#tab_livelink_pane').html(content);
                        Pachno.UI.Backdrop.reset();
                    });
            <?php else: ?>
                Pachno.UI.Backdrop.show('<?= make_url('get_partial_for_backdrop', $partial_options); ?>?' + $form.serialize());
            <?php endif; ?>
        };

        const submitSetupStep = function(e) {
            const $submit_button = $('.' + form_id + '_button'),
                url            = $form.attr("action");

            $submit_button.attr('disabled', true);
            $form.addClass('submitting');
            e.preventDefault();

            const submitStep = function () {
                return new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'POST',
                        data: $form.serialize(),
                        url: url,
                        success: resolve,
                        error: function (details) {
                            $form.removeClass('submitting');
                            $submit_button.attr('disabled', false);
                            reject(details);
                        }
                    });
                });
            };

            submitStep()
                .then(function (result) {
                    $form.addClass('repo-verified step-2');
                    $form.removeClass('submitting step-1');
                    $submit_button.attr('disabled', false);
                    $('#livelink_address_container').addClass('verified');
                    $step_input.val(2);

                    $repo_input.off('keypress');
                    $repo_input.off('keydown');
                    $repo_input.off('change');
                    $repo_input.keypress(resetStep);
                    $repo_input.keydown(resetStep);
                    $repo_input.change(resetStep);

                    $form.off('submit');
                    $form.submit(loadProjectInfo);
                }, function (details) {
                    Pachno.UI.Message.error(details.responseJSON.error);
                });
        };

        const resetStep = function (e) {
            e.preventDefault();

            $form.removeClass('repo-verified step-2');
            $form.addClass('step-1');
            $step_input.val(1);
            $repo_input.off('change');
            $repo_input.off('keypress');
            $repo_input.off('keydown');
            $('#livelink_address_container').removeClass('verified');

            $form.off('submit');
            $form.submit(submitSetupStep);
        };

        $form.off('submit');
        $form.submit(submitSetupStep);

        $change_button.off('click');
        $change_button.click(resetStep);
    });
</script>
